/* 	
	error.c 	part of TRIPP Traffic Rewriter for IP (v4) Packets
	by poplix@papuasia.org 2005

*/


#include "tripp.h"



#define ERRMSG_LEN 500
#define DBGMSG_LEN 500
#define WRNMSG_LEN 500

void print_error(int errcode,char *fn,char *message, ...){
   
   va_list ap;
   char errmsg[ERRMSG_LEN + 1];

  	va_start(ap, message);
  	vsnprintf(errmsg, ERRMSG_LEN, message, ap);
  	va_end(ap);
   
	fprintf(stderr,"ERROR: %s%s\n",fn,errmsg);
	exit(errcode);
}



void print_rt_error(char *fn,char *message, ...){
   
   va_list ap;
   char errmsg[ERRMSG_LEN + 1];

  	va_start(ap, message);
  	vsnprintf(errmsg, ERRMSG_LEN, message, ap);
  	va_end(ap);
   
	fprintf(stderr,"ERROR: %s%s\n",fn,errmsg);
	//SIGNAL TO PARENT
}




void print_debug(char *fn,char *message, ...){
   
   va_list ap;
   char errmsg[DBGMSG_LEN + 1];

  	va_start(ap, message);
  	vsnprintf(errmsg, DBGMSG_LEN, message, ap);
  	va_end(ap);
   
	fprintf(stdout,"DEBUG: %s%s\n",fn,errmsg);
	
}



void print_warning(char *fn,char *message, ...){
   
   va_list ap;
   char wrnmsg[WRNMSG_LEN + 1];

  	va_start(ap, message);
  	vsnprintf(wrnmsg, WRNMSG_LEN, message, ap);
  	va_end(ap);
   
	fprintf(stderr,"WARNING: %s%s\n",fn,wrnmsg);
	
}


