/* 	
	if.c 	part of TRIPP Traffic Rewriter for IP (v4) Packets
	by poplix@papuasia.org 2005

*/


#include "tripp.h"

#include <ifaddrs.h>

#ifdef BSD
#include <unistd.h>
#include <net/if_types.h>
#endif


#ifdef __linux__
#include <net/route.h>
#include <net/if_arp.h>
#endif

u_int setmtu(struct intf* ifi,u_int mtu){
	char cmdbuff[1024];
	ifi->oldmtu=ifi->mtu;
	sprintf(cmdbuff,"ifconfig %s mtu %d",ifi->name,mtu);
	system(cmdbuff);
	return 1;
}

u_int restoremtu(struct intf* ifi){
	if(ifi->oldmtu==0)return 0;
	char cmdbuff[1024];
	sprintf(cmdbuff,"ifconfig %s mtu %d",ifi->name,ifi->oldmtu);
	system(cmdbuff);
	return 1;
}



#ifdef IPFW

int frw_delete(char *ip,char *intf){
	char cmdbuff[1024];
	sprintf(cmdbuff,"%s del 000001 2> /dev/null 1> /dev/null\n",FRWPATH);
	system(cmdbuff);
	return 1;
}



int frw_deny(char *ip,char *intf){
	char cmdbuff[1024];
	frw_delete(NULL,NULL);
	sprintf(cmdbuff,"%s add 000001 deny ip from %s to any via %s in >/dev/null\n",FRWPATH,ip,intf);
	system(cmdbuff);
	return 1;
}


#endif





#ifdef IPTABLES
int frw_deny(char *ip,char *intf){
	char cmdbuff[1024];
	sprintf(cmdbuff,"%s -I INPUT -s %s -i %s -j DROP \n",FRWPATH,ip,intf);
	system(cmdbuff);
	return 1;
}

int frw_delete(char *ip,char *intf){
	char cmdbuff[1024];
	sprintf(cmdbuff,"%s -D INPUT -s %s -i %s -j DROP \n",FRWPATH,ip,intf);
	system(cmdbuff);
	return 1;
}
#endif



#ifdef IPCHAINS
int frw_deny(char *ip,char *intf){
	char cmdbuff[1024];
	sprintf(cmdbuff,"%s -I INPUT -s %s -i %s -j DROP \n",FRWPATH,ip,intf);
	system(cmdbuff);
	return 1;
}

int frw_delete(char *ip,char *intf){
	char cmdbuff[1024];
	sprintf(cmdbuff,"%s -D INPUT -s %s -i %s -j DROP \n",FRWPATH,ip,intf);
	system(cmdbuff);
	return 1;
}
#endif




#ifdef BSD
int route(char *net,char *oldif,char *newif){
	#define SILENT "> /dev/null"
	//#define SILENT ""
	char cmdbuff[1024];
	sprintf(cmdbuff,"%s delete -net %s -interface %s %s\n",ROUTEPATH,net,oldif,SILENT);
	system(cmdbuff);

	sprintf(cmdbuff,"%s add -net %s -interface %s %s\n",ROUTEPATH,net,newif,SILENT);
	system(cmdbuff);
}

int route_defgw(char *oldgw,char *newgw,char *oldif,char *newif){
	
	char cmdbuff[1024];
	sprintf(cmdbuff,"%s delete default %s\n",ROUTEPATH,oldif,SILENT);
	system(cmdbuff);
printf("%s\n",cmdbuff);
	sprintf(cmdbuff,"%s add default -interface %s %s\n",ROUTEPATH,newgw,newif,SILENT);
	system(cmdbuff);
printf("%s\n",cmdbuff);
}

#endif



#ifdef __linux__
int route(char *net,char *oldif,char *newif){
	#define SILENT "> /dev/null"
	//#define SILENT ""
	char cmdbuff[1024];
	sprintf(cmdbuff,"%s del -net %s dev %s %s\n",ROUTEPATH,net,oldif,SILENT);
	system(cmdbuff);

	sprintf(cmdbuff,"%s add -net %s dev %s %s\n",ROUTEPATH,net,newif,SILENT);
	system(cmdbuff);
}

int route_defgw(char *oldgw,char *newgw,char *oldif,char *newif){
	
	char cmdbuff[1024];
	sprintf(cmdbuff,"%s del default gw %s dev %s\n",ROUTEPATH,oldgw,oldif,SILENT);
	system(cmdbuff);

	sprintf(cmdbuff,"%s add default gw %s dev %s\n",ROUTEPATH,newgw,newif,SILENT);
	system(cmdbuff);

}
#endif



#ifdef BSD
  //BSD code

  //deve restituire ZERO se l'if e' down...!!!

  //fetifinfo sets:ifname, mtu, link-type,layer4 address,layer4 netmask,
 int getifinfo(char *name,struct intf *iface){
	struct 	ifaddrs 	*ifap, *ifa;
	int find=0;

	// get the list 
	if(getifaddrs(&ifap) < 0) return 0;
	

	if(!ifap) return 0; 
	//nota che ogni inf compare due volte in lista, una volta come AF_LINK e una AF_INET
	for(ifa = ifap; ifa; ifa = ifa->ifa_next)
	 if(!strcmp(name,ifa->ifa_name)){
	 	//copy only the first time
	 	if(find==0)strcpy(iface->name,name);
	 	find=1;
		if(ifa->ifa_addr->sa_family == AF_LINK){
			iface->mtu=((struct if_data*)ifa->ifa_data)->ifi_mtu;
			
			switch(((struct if_data*)ifa->ifa_data)->ifi_type){
				case IFT_ETHER:
					iface->type=DLT_EN10MB;
					break;
				case IFT_GIF:
				case IFT_LOOP:
					iface->type=DLT_LOOP;
					break;
					
				default:
					freeifaddrs(ifap);
					return 0;
			}
			
		}
		if(ifa->ifa_addr->sa_family == AF_INET){
			iface->ipaddr  = (u_int32_t) ((struct sockaddr_in*)ifa->ifa_addr)->sin_addr.s_addr;
			iface->netmask = (u_int32_t) ((struct sockaddr_in*)ifa->ifa_netmask)->sin_addr.s_addr;
		}
	  }
		
	freeifaddrs(ifap);
	return find;
	

 }
#endif
//end of BSD code



#ifdef __linux__
 //fetifinfo sets:ifname, mtu, link-type,layer4 address,layer4 netmask, 
 //layer2 address is handled by libnet in main()
 int getifinfo(char *name,struct intf *iface){
        int fd;
        struct ifconf   ifc;
        struct ifreq    ibuf[16],
                        ifr,
                        *ifrp,
                        *ifend;
        struct sockaddr_in sa;
        
		char ifname[1023];
        
        int find=0;

        if ( (fd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
                return 0;
        }

        memset(ibuf, 0, sizeof(struct ifreq)*16);
        ifc.ifc_len = sizeof ibuf;
        ifc.ifc_buf = (caddr_t) ibuf;

        /* gets interfaces list */
        if ( ioctl(fd, SIOCGIFCONF, (char*)&ifc) == -1 ||
             ifc.ifc_len < sizeof(struct ifreq)         ) {
                close(fd);
                return 0;
        }

        /* ifrp points to buffer and ifend points to buffer's end */
        ifrp = ibuf;
        ifend = (struct ifreq*) ((char*)ibuf + ifc.ifc_len);

        for (; ifrp < ifend; ifrp++) {
        	if(strcmp(ifrp->ifr_name,name))continue;
        	find=1;
        	strncpy(ifr.ifr_name, ifrp->ifr_name, sizeof(ifr.ifr_name));
			
         	//get if flags
         	if(ioctl(fd, SIOCGIFFLAGS, (char*)&ifr) == -1) { close(fd); return 0; };
			//if is down
			if ( !(ifr.ifr_flags & IFF_UP) )return 0;
	
            strncpy(iface->name, ifr.ifr_name, sizeof(iface->name));
            
            //get l3 addr
            if (ioctl(fd, SIOCGIFADDR, (char*)&ifr) == -1){ close(fd); return 0; };
                
          	if (ifr.ifr_ifru.ifru_addr.sa_family == AF_INET) {
			 	//save addr
			 	iface->ipaddr=((struct sockaddr_in *)&ifr.ifr_ifru.ifru_addr)->sin_addr.s_addr;
			 	
			 	//get netmask
			 	if(ioctl(fd, SIOCGIFNETMASK, (char*)&ifr) == -1){ close(fd); return 0; };
			 	iface->netmask=((struct sockaddr_in *)&ifr.ifr_ifru.ifru_netmask)->sin_addr.s_addr;
			 
			 	//get link-type
			 	if(ioctl(fd, SIOCGIFHWADDR, (char*)&ifr) == -1){ close(fd); return 0; };
			 	switch (ifr.ifr_hwaddr.sa_family) {
			 		//__linux__ encaps loop in eth frames
					case ARPHRD_LOOPBACK:
					case ARPHRD_ETHER:
					case ARPHRD_METRICOM:
						iface->type = DLT_EN10MB;
						break;
					
					default: 
						close(fd);
						return 0;
				}
			}else {//not AF_INET
				close(fd);
				return 0; 
			}
		//get MTU
		if(ioctl(fd, SIOCGIFMTU, &ifr) == -1){ close(fd); return 0; }
		iface->mtu=ifr.ifr_mtu;               
 		}
  close(fd);
  return 1;
  }
 
 #endif
 
 
 
 
 

