/* 	
	layer2.c 	part of TRIPP Traffic Rewriter for IP (v4) Packets
	by poplix@papuasia.org 2005

*/


#include "tripp.h"




int build_layer2(struct ip_packet *pk, libnet_t *libnet_hnd,struct tunnel *tun,u_int32_t gw){
    char *ethdst;
    libnet_ptag_t lneth=0;
    u_int32_t ipdst;
    
    if( ((pk->ip->ip_dst.s_addr & tun->outif.netmask) == (pk->ip->ip_src.s_addr & tun->outif.netmask))|| gw==0 )
      ipdst=pk->ip->ip_dst.s_addr;
	else
	  ipdst=gw;
	
	ethdst=arpget(ipdst);
	  
	if(ethdst==NULL){
		ethdst=arp_resolve(ipdst,libnet_hnd,tun);
		//arp_resolve deelaya tutto...
		if(ethdst==NULL)return 0;
		
		arpadd(ipdst,ethdst);
	}
	
	
	lneth=libnet_build_ethernet(ethdst, tun->outif.l2addr, ETHERTYPE_IP, NULL,0,libnet_hnd,0);                                             
	if(lneth==-1)
			fprintf(stderr, "Eth forging error: %s\n", libnet_geterror(libnet_hnd));
	
	
	return 1;
	}
	
	
	
	